<?php

defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: mosimage.php,v 1.23 2010-12-28 21:47:49 harry Exp $
 * @package Joomla
 * @subpackage H2N Mosimage Plugin
 * @copyright (C) 2010 Harry Klein - www.joomla-hklein.de
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license GNU/GPL, see LICENSE.php
 *
 * H2N Mosimage Plugin is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Mosimage Plugin is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport('joomla.event.plugin');

require_once JPATH_ROOT . DS.'plugins'.DS.'content'.DS.'mosimage'.DS.'helper'.DS.'LightboxHelper.php';
require_once JPATH_ROOT . DS.'plugins'.DS.'content'.DS.'mosimage'.DS.'helper'.DS.'ImageProperties.php';
require_once JPATH_ROOT . DS.'plugins'.DS.'content'.DS.'mosimage'.DS.'helper'.DS.'ThumbnailCreator.php';
require_once JPATH_ROOT . DS.'plugins'.DS.'content'.DS.'mosimage'.DS.'helper'.DS.'MosimageConfiguration.php';

class plgContentMosimage extends JPlugin {
	
	public function plgContentMosimage(&$subject, $config = null){
		parent::__construct($subject, $config);
		$this->loadLanguage( 'plg_content_mosimage', JPATH_ADMINISTRATOR);
	}

	/** 
	 */
	private function isRowOnFrontpage(&$row){
		$isFrontpage = 1;
		// empierisch ermmitelt
		if (isset ($row->parameters)){
			$isFrontpage = 0; 
		}
		// $inFrontpage = (JRequest::getCmd( 'view' ) == 'frontpage') == true? 1:0;
		return $isFrontpage;
	}
	
	/**
	 */
	public function onPrepareContent(&$row, &$params, $page=0 ) {
		// simple performance check to determine whether bot should process further
		if ( strpos( $row->text, 'mosimage' ) === false ) {
			return true;
		}
	
		$regex = '/{mosimage\s*.*?}/i';
	
		if (!JPluginHelper::isEnabled('content', 'mosimage')) {
			$row->text = preg_replace( $regex, '', $row->text );
			return true;
		}
	
		$pageParams = new JParameter($row->attribs);
		$globalParams = clone($params);
		$globalParams->merge($pagaParams);
		
		//count how many {mosimage} are in introtext if it is set to hidden.
		$introCount=0;
		if ( ! $globalParams->get('show_intro') &&  ! $this->isRowOnFrontpage($row)) {
			preg_match_all( $regex, $row->introtext, $matches );
			$introCount = count ( $matches[0] );
		}
	
		// find all instances of mambot and put in $matches
		preg_match_all( $regex, $row->text, $matches );
	
		// Number of mambots
		$count = count( $matches[0] );
	
		if ( $count ) {
			
			$document=& JFactory::getDocument();		
			$baseUrl = JURI::base().'plugins/content/mosimage';
			$document->addStyleSheet($baseUrl.'/css/mosimage.css');
			
			$config = new MosimageConfiguration($this->params);
								
			if(isset($_COOKIE['botmtscreenres'])){
	    		$botMtGlobals['screenres'] = explode('x', $_COOKIE['botmtscreenres']);
			} elseif(strpos($config->getFullsizeMaxWidth(), '%') || strpos($config->getFullsizeMaxHeight(), '%')) {
	        	$document->addScriptDeclaration('document.cookie= "botmtscreenres=" + screen.width+"x"+screen.height;');
	   		} 
	   		$config = new MosimageConfiguration($this->params);
			$images = $this->processImages( $row, $config, $introCount, $count );
	
			// store some vars in globals to access from the replacer
			$GLOBALS['botMosImageCount'] 	= 0;
			$GLOBALS['botMosImageArray'] 	=& $images;
	
			// perform the replacement
			$row->text = preg_replace_callback( $regex, 'botMosImage_replacer', $row->text );
	
			// clean up globals
			unset( $GLOBALS['botMosImageCount'] );
			unset( $GLOBALS['botMosImageArray'] );
	
			$lightboxType = $config->getLightboxType();
			$lightboxHelper = new LightboxHelper($lightboxType);
			$lightboxHelper->addScriptAndCssToDocument();
			
			return true;
		}
	}
	
	private function processImages ( &$row, MosimageConfiguration &$config, &$introCount, &$count ) {
		$images 		= array();
	
		// split on \n the images fields into an array
		$row->images 	= explode( "\n", $row->images );
		
		$rowImageCount = count( $row->images ); // Anzahl der Images
		if ($rowImageCount > $introCount + $count){
			$total = $introCount + $count;
		} else {
			$total = $rowImageCount;
		}

		for ( $i = $introCount; $i < $total; $i++ ) {
			$img = trim( $row->images[$i] );
	
			// split on pipe the attributes of the image
			if ( $img ) {
				$imgProperties = new ImageProperties($img,$config->isViewCaptionTextForThumbnail());

				$thumb_width = $config->getThumbnailMaxWidth();
				$thumb_heigth = $config->getThumbnailMaxHeight();
				$full_width = $config->getFullsizeMaxWidth();
				$full_height = $config->getFullsizeMaxHeight();
				$viewCaptionForFullSizeImage = $config->isViewCaptionTextForFullsize();
				
				$xpos=strpos($full_width, '%');
				$ypos=strpos($full_height, '%');
				if($xpos || $ypos ) {			 	
	    			if(!isset($screenres)) {
	    				$screenres = array(1024, 768);
	    			}
	    			if($xpos) {
	    				$full_width = $screenres[0] * substr($full_width, 0, $xpos) / 100;
	    			}
	    			if($ypos) {
	    				$full_height = $screenres[1] * substr($full_height, 0, $ypos) / 100;
	    			}
				}
				$thumbnailCreator = new ThumbnailCreator();
				$mosthumbProperties = $thumbnailCreator->createThumbnailImage($config, $imgProperties->getAbsoluteFileName(), $thumb_width, $thumb_heigth);
				$mosimageProperties = $thumbnailCreator->createResizedImage  ($config, $imgProperties->getAbsoluteFileName(), $full_width,  $full_height);
				
				if (!$mosthumbProperties || !$mosimageProperties){
					return;
				}
						
				$lightboxHelper = new LightboxHelper($config->getLightboxType());
				$images[] = $this->buildHtmlForImage($lightboxHelper, $mosthumbProperties, $mosimageProperties, $imgProperties, $config);
			}
		}
		return $images;
	}
	
	
	private function buildHtmlForImage(&$lightboxHelper, &$mosthumbProperties, &$mosimageProperties, &$imgProperties, &$config){
		$lightboxRel   = $lightboxHelper->getRel();
		$lightboxClass = $lightboxHelper->getCssClass();
		$thumbSize = ' width="'. $mosthumbProperties->getWidth() .'" height="'. $mosthumbProperties->getHeight() .'"';
		
		$image = '<a href="'. $mosimageProperties->getUrl() .'"';
		$image.= ' rel="'.$lightboxRel.'"';
		$image.= ' class="'.$lightboxClass .'"';
		$image.= ' title="' . ($config->isViewCaptionTextForFullsize() ? $imgProperties->getCaptionText():'') .'"';
		$image.= '>';
		$image.= '<img  class="mosimgage-inner" src="'. $mosthumbProperties->getUrl()  .'"';
		$image.= $thumbSize;
		$image.= $imgProperties->getImageAlignAsHtml();
		$image.=' alt="'. $imgProperties->getAltText() .'"';
		$image.=' title="'. $imgProperties->getCaptionText() .'"';
		$image.=' border="'. $imgProperties->getBorderWidth() .'"';
		$image.=' /></a>';

		$caption = '';
		if ( $config->isViewCaptionTextForThumbnail()) {
			$widthInner = $mosthumbProperties->getWidth();
			$widthOuter = $mosthumbProperties->getWidth() + 26;
			if ($imgProperties->isCaptionTextEmpty()){
				$cssDisplay =" display: none;";
			} else {
				$cssDisplay = '';
			}
			$cssWidh='width: '. $widthInner . 'px;';
				
			$caption_valign  = $config->getThumbnailCaptionAlign();
			$caption = '<span class="mosimgage-inner-'.$caption_valign.'" style="'.$cssWidh . $cssDisplay.'" ';
			$caption .= '>';
			$caption .= $imgProperties->getCaptionText();
			$caption .= '</span>';
				
			if ($imgProperties->getImageAlgin() == ""){
				$cssClassOuter 		= 'mosimgage-outer-none';
			} else {
				$cssClassOuter 		= 'mosimgage-outer-'. $imgProperties->getImageAlgin();
			}
			$img = '<span class="' . $cssClassOuter . '" style="width: '. $widthOuter . 'px;">';

			if ($caption_valign == 'top' && $caption){
				$img .= $caption;
			}
			$img .= $image;

			if ($caption_valign == 'bottom' && $caption){
				$img .= $caption;
			}
				
			$img .='</span>';
		} else {
			$img = $image;
		}

		return $img;
	}
}
	

/**
 * Replaces the matched tags an image
 * @param array An array of matches (see preg_match_all)
 * @return string
 */
function botMosImage_replacer( &$matches ) {
	$i = $GLOBALS['botMosImageCount']++;
	return @$GLOBALS['botMosImageArray'][$i];
}

?>