<?php

defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: ImageProperties.php,v 1.1 2010-12-20 22:58:30 harry Exp $
 * @package Joomla
 * @subpackage H2N Mosimage Plugin
 * @copyright (C) 2010 Harry Klein - www.joomla-hklein.de
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license GNU/GPL, see LICENSE.php
 *
 * H2N Mosimage Plugin is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Mosimage Plugin is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

class ImageProperties {

	const IMAGE_FILENAME = 0;
	const IMAGE_ALIGN = 1;
	const ALT_TEXT = 2;
	const BORDER_WDTH = 3;
	const CAPTION = 4;
	const CAPTION_POSITION = 5;
	const CAPTION_ALIGN = 6;
	const CAPTION_WIDTH = 7;

	private $attrib;
	private $displayThumbCaption;

	function __construct($imagePropertiesAsLine, $displayThumbCaption){
		$this->attrib = explode( '|', trim($imagePropertiesAsLine));
		$this->displayThumbCaption = $displayThumbCaption;
	}

	public function getRelativeFileName(){
		return trim($this->attrib[0]);
	}

	public function getImageAlgin() {
		if ( !isset($this->attrib[self::IMAGE_ALIGN]) || !$this->attrib[self::IMAGE_ALIGN] ) {
			return '';
		}
		return $this->attrib[self::IMAGE_ALIGN];
		
	}
	
	public function getImageAlignAsHtml(){
		if ( $this->displayThumbCaption){
			return '';
		} 
		
		$imageAlign = $this->getImageAlgin();
		switch ($imageAlign){
			case 'left':
			case 'right':
				return ' style="float: '. $imageAlign .';"';
			//case 'middle':		
			//	return ' align="middle"'; 
			
		}
		return '';
	}
	

	public function getAltText(){
		if ( !isset($this->attrib[self::ALT_TEXT]) || !$this->attrib[self::ALT_TEXT] ) {
			return 'Image';
		} else {
			return htmlspecialchars( $this->attrib[self::ALT_TEXT] );
		}
	}

	public function getBorderWidth(){
		if ( !isset($this->attrib[self::BORDER_WDTH]) || !$this->attrib[self::BORDER_WDTH] ) {
			return 0;
		}
		return $this->attrib[self::BORDER_WDTH];
	}

	public function getCaptionText(){
		if ( !isset($this->attrib[self::CAPTION]) || !$this->attrib[self::CAPTION] ) {
			return '&nbsp;';
		}
		return $this->attrib[self::CAPTION];
	}
	
	public function isCaptionTextEmpty(){
		if ( !isset($this->attrib[self::CAPTION]) || !$this->attrib[self::CAPTION] ) {
			return true;
		}
		return false;
	}
	

	public function getCaptionPosition(){
		if ( !isset($attrib[self::CAPTION_POSITION]) || !$attrib[self::CAPTION_POSITION] ) {
			return '';
		}
		switch ($this->attrib[self::CAPTION_POSITION]){
			case 'bottom':
			case 'top':
				return $this->attrib[self::CAPTION_POSITION];
		}
		return'';
	}

	public function getCaptionAlignment(){
		if ( !isset($this->attrib[self::CAPTION_ALIGN]) || !$this->attrib[self::CAPTION_ALIGN] ) {
			return '';
		}
		switch ($this->attrib[self::CAPTION_ALIGN]){
			case 'rigth':
			case 'left':
				return $attrib[self::CAPTION_ALIGN];
		}
		return '';
	}

	public function getCaptionWidthAsCss(){
		if ( !isset($this->attrib[self::CAPTION_WIDTH]) || !$this->attrib[self::CAPTION_WIDTH] ) {
			return '';
		}
		return ' width: '. $this->attrib[self::CAPTION_WIDTH] .'px;';
	}


	public function getAbsoluteFileName(){
		return JPATH_SITE .DS.'images'.DS.'stories'.DS.$this->getRelativeFileName();
	}

	public function getImageSizeAsHtml(){
		if ( function_exists( 'getimagesize' ) ) {
			$size 	= @getimagesize($this->getAbsoluteFileName());
			if (is_array( $size )) {
				return ' width="'. $size[0] .'" height="'. $size[1] .'"';
			}
		}
		return '';
	}
}
?>